/*
============================================================================================


	JS-GIS API: JavaScript Geographic Information System browser library
 	Copyright (C) 2001, 2002 Luca Sigfrido Percich

	The JS-GIS API is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation: please refer to

	http://www.gnu.org/licenses/gpl.html

	The JS-GIS API is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.


============================================================================================

	jsgis_mapctrls.js	standard map controls

 	Author:			Luca Sigfrido Percich (luca.percich@reacoop.it)
 	Version:		2.0
 	Last updated:		apr 17, 2002

	Usage: 
		- include this script in the <HEAD> of the toolbar page;
		- define a mc-dropdown style

		- use the following instructions inside a <form> tag
			(make sure it's the first form defined in the page)

			document.write(ctrlZoom())		// zoom level control
			document.write(ctrlTheme())		// theme control
			document.write(ctrlTool('','', ))	// tool control (imagemaps only)
			document.write(ctrlTool('Zoom +','Zoom -', ))	// tool control (full)

			document.write(tool_button('zoomout', 101, (parent.Map.zoomLevel > 0))) // Zoom + tool button
				(assumes zoomout.png, zoomout_gray.png and zoomout_act.png exist in current dir)

			document.write(cmd_button(bname, isgray, fn_call))  // command button
============================================================================================
*/



// Assumes Map has been defined in the parent frameset
var ctrlMap = parent.Map
var m = parent.Map
var t = m.tool


function ctrlZoom()
{
	var buf = '<select name="ZOOMLEVEL" size="1" class="mc-dropdown" onChange="javascript: changeLevel()">'

	for(ct=0;ct < ctrlMap.project.zoomLevels.items.length; ct++)
		buf += '<option value="' + ct + '"' + isSelected(ct == ctrlMap.zoomLevel) + '>' + ctrlMap.project.zoomLevels.items[ct].name + '</option>'

	buf += '</select>'

	return buf
}


function ctrlTheme()
{
	var buf = '<select name="THEME" size="1" class="mc-dropdown" onChange="javascript: changeTheme()">'

	for(ct=0;ct < ctrlMap.project.themes.items.length; ct++)
		if (ctrlMap.project.themes.items[ct].isAvailable(ctrlMap.zoomLevel))
			buf += '<option value="' + ct + '"' + isSelected(ct == ctrlMap.theme) + '>' + ctrlMap.project.themes.items[ct].name + '</option>'

	buf += '</select>'

	return buf
}



// if txt_zoomin txt_zoomout are non-empty, zoomin and zoomout tools will be added to the list
function ctrlTool(txt_zoomin, txt_zoomout)
{
	var buf = '<select name="TOOL" size="1" class="mc-dropdown" onChange="javascript: changeTool()">'
	var tot = 0
	var sel

	if ((ctrlMap.tool == 999) && (txt_zoomin != ''))
		{
		buf += '<option value="999" SELECTED>[--------]</option>'
		tot += 1
		}

	if ((ctrlMap.zoomLevel < ctrlMap.project.zoomLevels.items.length - 1) && txt_zoomin != '')
		{
		buf += '<option value="100"' + isSelected(ctrlMap.tool == 100) + '>' + txt_zoomin + '</option>'
		tot += 1
		}

	if (ctrlMap.zoomLevel > 0  && txt_zoomout != '')
		{
	  	buf += '<option value="101"' + isSelected(ctrlMap.tool == 101) + '>' + txt_zoomout + '</option>'
		tot += 1
		}

	var selTool = (txt_zoomin != '') ? ctrlMap.tool : ctrlMap.imagemap
	for(ct=0;ct < ctrlMap.project.imagemaps.items.length; ct++)
	    if (ctrlMap.project.imagemaps.items[ct].isAvailable(ctrlMap.zoomLevel))
		{
		buf += '<option value="' + ct + '"' + isSelected(ct == selTool) + '>' + ctrlMap.project.imagemaps.items[ct].name + '</option>'
		tot += 1
		}

	if (tot == 0)
		buf += '<option value="999">[--------]</option>'		

	buf += '</select>'

	// if (tot > 0)
		return buf
	//  else
	//	return '[No active layers]'
}



// -------------------------------------------------------------------------------------------------
//
// local functions
//
// -------------------------------------------------------------------------------------------------


function getSelectValue(s)
{
	if (document.all)
	   return s.value
	 else
	   return s.options[s.selectedIndex].value
}



function getCombo(szName)
{
	return document.forms[0].elements[szName]
}


function changeLevel()
{
	ctrlMap.setZoomLevel(getSelectValue(getCombo('ZOOMLEVEL')))
}


function changeTheme()
{
	ctrlMap.setTheme(getSelectValue(getCombo('THEME')))
}


function changeTool()
{
	ctrlMap.setTool(getSelectValue(getCombo('TOOL')))
}

function isSelected(condition)
{
	return (condition) ? ' SELECTED' : ''
}




function st(t)
{
	ctrlMap.setTool(t)
}

function tool_button(bname, btool, isgray)
{
	var szBuf = ''
	if (btool  < 0) btool = ctrlMap.imagemap

	if (btool < 0)
	{	if (ctrlMap.availImagemaps.length > 0)
			btool = ctrlMap.availImagemaps[0]
		   else
		   {
			btool = 999
			isgray = 1
		   }
	}
	if (btool != t && !isgray) szBuf += '<a href="#" onclick="st(' + btool + ')">'
	szBuf += '<img src="tool_' + bname
	if (isgray)
		szBuf += '_gray'
	else if (btool == t) 
		szBuf += '_act'
	szBuf += parent.projExt + '" width="24" height="22" border="0">'
	if (btool != t && !isgray) szBuf += '</a>'

	return szBuf
}


function cmd_button(bname, isgray, fn_call)
{
	var szBuf = ''


	if (!isgray) szBuf += '<a href="#" onclick="' + fn_call + '">'
	szBuf += '<img src="' + bname

	if (isgray) szBuf += '_gray'

	szBuf += parent.projExt + '" width="24" height="22" border="0">'

	if (!isgray) szBuf += '</a>'

	return szBuf
}

