/*
============================================================================================


	JS-GIS API: JavaScript Geographic Information System browser library
 	Copyright (C) 2001, 2002 Luca Sigfrido Percich

	The JS-GIS API is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation: please refer to

	http://www.gnu.org/licenses/gpl.html

	The JS-GIS API is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.


============================================================================================

	jsgis_utils.js		standard utility functions

 	Author:			Luca Sigfrido Percich (luca.percich@reacoop.it)
 	Version:		2.0
 	Last updated:		may 02, 2002

	Usage: 
		- include this script in the <HEAD> of the main page
		- requires jsgis_points to use selection.

============================================================================================
*/



// Locates a point on the Map
function findXY(X, Y, id, objTable, newZoom)
{
	id = (id) ? id : 'selection'
	objTable = (objTable) ? objTable : ''
	newZoom = (newZoom) ? newZoom : Map.zoomLevel
	

	if (X == 0 || Y == 0)
		{
			if (selection)
			{
				selection.visible	= false
				selection.id		= ''
				selection.table		= ''
			}
			return
		}

	if(selection)
	{
		selection.id = id
		selection.table = objTable
		selection.obj.x = X
		selection.obj.y = Y
		selection.visible = true
	}

	Map.gotoXY(X, Y, newZoom)
}



// Loads an object's html data page
function info(objCode, objTable, isList)
{
	var infoCode = (objCode) ? objCode : ''
	if (infoCode && objTable) infoCode = '_' + infoCode
	if (objTable) infoCode = objTable + infoCode
	
	var szBuf = Project.rootDir + 'docs/' + lang + '/'

	if (isList)
	{
		szBuf += 'elenco_' + Map.theme + '.htm'
		if (infoCode) szBuf += '#' + infoCode
		docpage.document.location.href = szBuf
	}
	else if (infoCode) docpage.document.location.href = szBuf + infoCode + '.htm'
			
}


// shows object's info and locates it
function infoXY(objCode, objTable, X, Y)
{
	info(objCode, objTable)
	findXY(X, Y, objCode, objTable, Map.zoomLevel)
}


